"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * Created by artak on 3/2/17.
 */
// ** ActorModel is a general model for describing both client and server nodes/actors
var ActorModel =
/*#__PURE__*/
function () {
  function ActorModel() {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, ActorModel);

    var id = data.id,
        _data$online = data.online,
        online = _data$online === void 0 ? true : _data$online,
        address = data.address,
        options = data.options;
    this.id = id;
    this.online = false;

    if (online) {
      this.setOnline();
    }

    this.address = address;
    this.options = options || {};
    this.pingStamp = null;
    this.ghost = false;
    this.fail = false;
    this.stop = false;
  }

  _createClass(ActorModel, [{
    key: "toJSON",
    value: function toJSON() {
      return {
        id: this.id,
        address: this.address,
        options: this.options,
        fail: this.fail,
        stop: this.stop,
        online: this.online,
        ghost: this.ghost
      };
    }
  }, {
    key: "getId",
    value: function getId() {
      return this.id;
    }
  }, {
    key: "markStopped",
    value: function markStopped() {
      this.stop = Date.now();
      this.setOffline();
    }
  }, {
    key: "markFailed",
    value: function markFailed() {
      this.fail = Date.now();
      this.setOffline();
    } // ** marking ghost means that there was some ping delay but that doeas not actually mean that its not there

  }, {
    key: "markGhost",
    value: function markGhost() {
      this.ghost = Date.now();
    }
  }, {
    key: "isGhost",
    value: function isGhost() {
      return !!this.ghost;
    }
  }, {
    key: "isOnline",
    value: function isOnline() {
      return !!this.online;
    }
  }, {
    key: "setOnline",
    value: function setOnline() {
      this.online = Date.now();
      this.ghost = false;
      this.fail = false;
      this.stop = false;
    }
  }, {
    key: "setOffline",
    value: function setOffline() {
      this.online = false;
    }
  }, {
    key: "ping",
    value: function ping(stamp) {
      this.pingStamp = stamp;
      this.setOnline();
    }
  }, {
    key: "setId",
    value: function setId(newId) {
      this.id = newId;
    }
  }, {
    key: "setAddress",
    value: function setAddress(address) {
      this.address = address;
    }
  }, {
    key: "getAddress",
    value: function getAddress() {
      return this.address;
    }
  }, {
    key: "setOptions",
    value: function setOptions(options) {
      this.options = options;
    }
  }, {
    key: "mergeOptions",
    value: function mergeOptions(options) {
      this.options = Object.assign({}, this.options, options);
      return this.options;
    }
  }, {
    key: "getOptions",
    value: function getOptions() {
      return this.options;
    }
  }]);

  return ActorModel;
}();

exports["default"] = ActorModel;