"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _enum = require("./enum");

var _globals = _interopRequireDefault(require("./globals"));

var _actor = _interopRequireDefault(require("./actor"));

var _errors = require("./errors");

var _sockets = require("./sockets");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var _private = new WeakMap();

var Client =
/*#__PURE__*/
function (_DealerSocket) {
  _inherits(Client, _DealerSocket);

  function Client() {
    var _context;

    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        id = _ref.id,
        options = _ref.options,
        config = _ref.config;

    _classCallCheck(this, Client);

    options = options || {};
    config = config || {};
    _this = _possibleConstructorReturn(this, _getPrototypeOf(Client).call(this, {
      id: id,
      options: options,
      config: config
    }));
    var _scope = {
      server: null,
      pingInterval: null
    };

    _this.on(_sockets.SocketEvent.DISCONNECT, (_context = _assertThisInitialized(_this), _serverFailHandler).bind(_context));

    _this.on(_sockets.SocketEvent.RECONNECT, (_context = _assertThisInitialized(_this), _serverReconnectHandler).bind(_context));

    _this.on(_sockets.SocketEvent.RECONNECT_FAILURE, function () {
      return _this.emit(_enum.events.SERVER_RECONNECT_FAILURE, _scope.server.toJSON());
    });

    _this.onTick(_enum.events.SERVER_STOP, (_context = _assertThisInitialized(_this), _serverStopHandler).bind(_context), true);

    _this.onTick(_enum.events.OPTIONS_SYNC, (_context = _assertThisInitialized(_this), _serverOptionsSync).bind(_context), true);

    _private.set(_assertThisInitialized(_this), _scope);

    return _this;
  }

  _createClass(Client, [{
    key: "getServerActor",
    value: function getServerActor() {
      var _private$get = _private.get(this),
          server = _private$get.server;

      return server;
    }
  }, {
    key: "setOptions",
    value: function setOptions(options) {
      var notify = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      _get(_getPrototypeOf(Client.prototype), "setOptions", this).call(this, options);

      if (notify) {
        this.tick({
          event: _enum.events.OPTIONS_SYNC,
          data: {
            actorId: this.getId(),
            options: options
          },
          mainEvent: true
        });
      }
    } // ** returns a promise which resolves with server model after server replies to events.CLIENT_CONNECTED

  }, {
    key: "connect",
    value: function () {
      var _connect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(serverAddress, timeout) {
        var _scope, requestData, _ref2, actorId, options, clientConnectError;

        return _regenerator["default"].wrap(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _scope = _private.get(this); // actually connected

                _context2.next = 4;
                return _get(_getPrototypeOf(Client.prototype), "connect", this).call(this, serverAddress, timeout);

              case 4:
                requestData = {
                  event: _enum.events.CLIENT_CONNECTED,
                  data: {
                    actorId: this.getId(),
                    options: this.getOptions()
                  },
                  mainEvent: true
                };
                _context2.next = 7;
                return this.request(requestData);

              case 7:
                _ref2 = _context2.sent;
                actorId = _ref2.actorId;
                options = _ref2.options;
                // ** creating server model and setting it online
                _scope.server = new _actor["default"]({
                  id: actorId,
                  options: options,
                  online: true,
                  address: serverAddress
                });

                _startServerPinging.call(this);

                return _context2.abrupt("return", {
                  actorId: actorId,
                  options: options
                });

              case 15:
                _context2.prev = 15;
                _context2.t0 = _context2["catch"](0);
                clientConnectError = new _errors.ZeronodeError({
                  socketId: this.getId(),
                  code: _errors.ErrorCodes.CLIENT_CONNECT,
                  error: _context2.t0
                });
                clientConnectError.description = "Error while disconnecting client '".concat(this.getId(), "'");
                this.emit('error', clientConnectError);

              case 20:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee, this, [[0, 15]]);
      }));

      function connect(_x, _x2) {
        return _connect.apply(this, arguments);
      }

      return connect;
    }()
  }, {
    key: "disconnect",
    value: function () {
      var _disconnect = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee2(options) {
        var _scope, server, disconnectData, requestOb, clientDisconnectError;

        return _regenerator["default"].wrap(function _callee2$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.prev = 0;
                _scope = _private.get(this);
                server = this.getServerActor();
                disconnectData = {
                  actorId: this.getId()
                };

                if (options) {
                  disconnectData.options = options;
                }

                if (!(server && server.isOnline())) {
                  _context3.next = 10;
                  break;
                }

                requestOb = {
                  event: _enum.events.CLIENT_STOP,
                  data: disconnectData,
                  mainEvent: true
                };
                _context3.next = 9;
                return this.request(requestOb);

              case 9:
                _scope.server = null;

              case 10:
                _stopServerPinging.call(this);

                _get(_getPrototypeOf(Client.prototype), "disconnect", this).call(this);

                _context3.next = 19;
                break;

              case 14:
                _context3.prev = 14;
                _context3.t0 = _context3["catch"](0);
                clientDisconnectError = new _errors.ZeronodeError({
                  socketId: this.getId(),
                  code: _errors.ErrorCodes.CLIENT_DISCONNECT,
                  error: _context3.t0
                });
                clientDisconnectError.description = "Error while disconnecting client '".concat(this.getId(), "'");
                this.emit('error', clientDisconnectError);

              case 19:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee2, this, [[0, 14]]);
      }));

      function disconnect(_x3) {
        return _disconnect.apply(this, arguments);
      }

      return disconnect;
    }()
  }, {
    key: "request",
    value: function request() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          event = _ref3.event,
          data = _ref3.data,
          timeout = _ref3.timeout,
          mainEvent = _ref3.mainEvent;

      var server = this.getServerActor(); // this is first request, and there is no need to check if server online or not

      if (mainEvent && event === _enum.events.CLIENT_CONNECTED) {
        return _get(_getPrototypeOf(Client.prototype), "request", this).call(this, {
          event: event,
          data: data,
          timeout: timeout,
          mainEvent: mainEvent
        });
      }

      if (!server || !server.isOnline()) {
        var serverOfflineError = new Error("Server is offline during request, on client: ".concat(this.getId()));
        return Promise.reject(new _errors.ZeronodeError({
          socketId: this.getId(),
          error: serverOfflineError,
          code: _errors.ErrorCodes.SERVER_IS_OFFLINE
        }));
      }

      return _get(_getPrototypeOf(Client.prototype), "request", this).call(this, {
        event: event,
        data: data,
        timeout: timeout,
        to: server.getId(),
        mainEvent: mainEvent
      });
    }
  }, {
    key: "tick",
    value: function tick() {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          event = _ref4.event,
          data = _ref4.data,
          mainEvent = _ref4.mainEvent;

      var server = this.getServerActor();

      if (!server || !server.isOnline()) {
        var serverOfflineError = new Error("Server is offline during request, on client: ".concat(this.getId()));
        return Promise.reject(new _errors.ZeronodeError({
          socketId: this.getId(),
          error: serverOfflineError,
          code: _errors.ErrorCodes.SERVER_IS_OFFLINE
        }));
      }

      _get(_getPrototypeOf(Client.prototype), "tick", this).call(this, {
        event: event,
        data: data,
        to: server.getId(),
        mainEvent: mainEvent
      });
    }
  }]);

  return Client;
}(_sockets.Dealer);

exports["default"] = Client;

function _serverFailHandler() {
  try {
    var server = this.getServerActor();
    if (!server || !server.isOnline()) return;

    _stopServerPinging.call(this);

    server.markFailed();
    this.emit(_enum.events.SERVER_FAILURE, server.toJSON());
  } catch (err) {
    var serverFailHandlerError = new _errors.ZeronodeError({
      socketId: this.getId(),
      code: _errors.ErrorCodes.SERVER_RECONNECT_HANDLER,
      error: err
    });
    serverFailHandlerError.description = "Error while handling server failure on client ".concat(this.getId());
    this.emit('error', serverFailHandlerError);
  }
}

function _serverReconnectHandler() {
  return _serverReconnectHandler2.apply(this, arguments);
}

function _serverReconnectHandler2() {
  _serverReconnectHandler2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3() {
    var server, requestObj, _ref6, actorId, options, serverReconnectHandlerError;

    return _regenerator["default"].wrap(function _callee3$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.prev = 0;
            server = this.getServerActor();
            requestObj = {
              event: _enum.events.CLIENT_CONNECTED,
              data: {
                actorId: this.getId(),
                options: this.getOptions()
              },
              mainEvent: true
            };
            _context4.next = 5;
            return this.request(requestObj);

          case 5:
            _ref6 = _context4.sent;
            actorId = _ref6.actorId;
            options = _ref6.options;

            if (server) {
              _context4.next = 10;
              break;
            }

            throw new Error("Server actor is not available on client '".concat(this.getId(), "'"));

          case 10:
            server.setId(actorId);
            server.setOnline();
            server.setOptions(options);
            this.emit(_enum.events.SERVER_RECONNECT, server.toJSON());

            _startServerPinging.call(this);

            _context4.next = 22;
            break;

          case 17:
            _context4.prev = 17;
            _context4.t0 = _context4["catch"](0);
            serverReconnectHandlerError = new _errors.ZeronodeError({
              socketId: this.getId(),
              code: _errors.ErrorCodes.SERVER_RECONNECT_HANDLER,
              error: _context4.t0
            });
            serverReconnectHandlerError.description = "Error while handling server reconnect on client ".concat(this.getId());
            this.emit('error', serverReconnectHandlerError);

          case 22:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee3, this, [[0, 17]]);
  }));
  return _serverReconnectHandler2.apply(this, arguments);
}

function _serverStopHandler() {
  try {
    var server = this.getServerActor(); // ** TODO:: this should not happen, please describe the situation

    if (!server) {
      throw new Error("Server actor is not available on client '".concat(this.getId(), "'"));
    }

    _stopServerPinging.call(this);

    server.markStopped();
    this.emit(_enum.events.SERVER_STOP, server.toJSON());
  } catch (err) {
    var serverStopHandlerError = new _errors.ZeronodeError({
      socketId: this.getId(),
      code: _errors.ErrorCodes.SERVER_STOP_HANDLER,
      error: err
    });
    serverStopHandlerError.description = "Error while handling server stop on client ".concat(this.getId());
    this.emit('error', serverStopHandlerError);
  }
}

function _serverOptionsSync(_ref5) {
  var options = _ref5.options,
      actorId = _ref5.actorId;

  try {
    var server = this.getServerActor();

    if (!server) {
      throw new Error("Server actor is not available on client '".concat(this.getId(), "'"));
    }

    server.setOptions(options);
    this.emit(_enum.events.OPTIONS_SYNC, {
      id: server.getId(),
      newOptions: options
    });
  } catch (err) {
    var serverOptionsSyncHandlerError = new _errors.ZeronodeError({
      socketId: this.getId(),
      code: _errors.ErrorCodes.SERVER_OPTIONS_SYNC_HANDLER,
      error: err
    });
    serverOptionsSyncHandlerError.description = "Error while handling server options sync on client ".concat(this.getId());
    this.emit('error', serverOptionsSyncHandlerError);
  }
}

function _startServerPinging() {
  var _this2 = this;

  var _scope = _private.get(this);

  var pingInterval = _scope.pingInterval;

  if (pingInterval) {
    clearInterval(pingInterval);
  }

  var config = this.getConfig();
  var interval = config.CLIENT_PING_INTERVAL || _globals["default"].CLIENT_PING_INTERVAL;
  _scope.pingInterval = setInterval(function () {
    try {
      var pingData = {
        actor: _this2.getId(),
        stamp: Date.now()
      };

      _this2.tick({
        event: _enum.events.CLIENT_PING,
        data: pingData,
        mainEvent: true
      });
    } catch (err) {
      var pingError = new _errors.ZeronodeError({
        socketId: _this2.getId(),
        code: _errors.ErrorCodes.SERVER_PING_ERROR,
        error: err
      });

      _this2.emit('error', pingError);
    }
  }, interval);
}

function _stopServerPinging() {
  var _private$get2 = _private.get(this),
      pingInterval = _private$get2.pingInterval;

  if (pingInterval) {
    clearInterval(pingInterval);
  }
}