"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ErrorCodes = exports.ZeronodeError = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Created by dave on 7/11/17.
 */
var ErrorCodes = {
  ALREADY_BINDED: 1,
  SOCKET_ISNOT_ONLINE: 2,
  NO_NEXT_HANDLER_AVAILABLE: 3,
  REQUEST_TIMEOUTED: 4,
  ALREADY_CONNECTED: 5,
  CONNECTION_TIMEOUT: 6,
  SERVER_UNBIND: 7,
  SERVER_ACTOR_NOT_AVAILABLE: 8,
  SERVER_STOP_HANDLER: 9,
  SERVER_OPTIONS_SYNC_HANDLER: 10,
  SERVER_PING_ERROR: 11,
  CLIENT_OPTIONS_SYNC_HANDLER: 12,
  SERVER_RECONNECT_HANDLER: 13,
  NODE_NOT_FOUND: 14,
  CLIENT_DISCONNECT: 15,
  CLIENT_CONNECT: 16,
  SERVER_IS_OFFLINE: 17
};
exports.ErrorCodes = ErrorCodes;

var ZeronodeError =
/*#__PURE__*/
function (_Error) {
  _inherits(ZeronodeError, _Error);

  function ZeronodeError() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        socketId = _ref.socketId,
        envelopId = _ref.envelopId,
        code = _ref.code,
        error = _ref.error,
        message = _ref.message,
        description = _ref.description;

    _classCallCheck(this, ZeronodeError);

    error = error || {};
    message = message || error.message;
    description = description || message;
    _this = _possibleConstructorReturn(this, _getPrototypeOf(ZeronodeError).call(this, message));
    _this.socketId = socketId;
    _this.code = code;
    _this.envelopId = envelopId;
    _this.error = error;
    _this.description = description;
    return _this;
  }

  return ZeronodeError;
}(_wrapNativeSuper(Error));

exports.ZeronodeError = ZeronodeError;
var _default = {
  ErrorCodes: ErrorCodes,
  ZeronodeError: ZeronodeError
};
exports["default"] = _default;