"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _underscore = _interopRequireDefault(require("underscore"));

var _enum = require("./enum");

var _globals = _interopRequireDefault(require("./globals"));

var _actor = _interopRequireDefault(require("./actor"));

var _errors = require("./errors");

var _sockets = require("./sockets");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var _private = new WeakMap();

var Server =
/*#__PURE__*/
function (_RouterSocket) {
  _inherits(Server, _RouterSocket);

  function Server() {
    var _context;

    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        id = _ref.id,
        bind = _ref.bind,
        config = _ref.config,
        options = _ref.options;

    _classCallCheck(this, Server);

    options = options || {};
    config = config || {};
    _this = _possibleConstructorReturn(this, _getPrototypeOf(Server).call(this, {
      id: id,
      options: options,
      config: config
    }));
    var _scope = {
      clientModels: new Map(),
      clientCheckInterval: null
    };

    _private.set(_assertThisInitialized(_this), _scope);

    _this.setAddress(bind); // ** ATTACHING client connected


    _this.onRequest(_enum.events.CLIENT_CONNECTED, (_context = _assertThisInitialized(_this), _clientConnectedRequest).bind(_context), true); // ** ATTACHING client stop


    _this.onRequest(_enum.events.CLIENT_STOP, (_context = _assertThisInitialized(_this), _clientStopRequest).bind(_context), true); // ** ATTACHING client ping


    _this.onTick(_enum.events.CLIENT_PING, (_context = _assertThisInitialized(_this), _clientPingTick).bind(_context), true); // ** ATTACHING CLIENT OPTIONS SYNCING


    _this.onTick(_enum.events.OPTIONS_SYNC, (_context = _assertThisInitialized(_this), _clientOptionsSync).bind(_context), true);

    return _this;
  }

  _createClass(Server, [{
    key: "getClientById",
    value: function getClientById(clientId) {
      var _private$get = _private.get(this),
          clientModels = _private$get.clientModels;

      return clientModels.has(clientId) ? clientModels.get(clientId) : null;
    }
  }, {
    key: "getOnlineClients",
    value: function getOnlineClients() {
      var _private$get2 = _private.get(this),
          clientModels = _private$get2.clientModels;

      var onlineClients = [];
      clientModels.forEach(function (actor) {
        if (actor.isOnline()) {
          onlineClients.push(actor);
        }
      }, this);
      return onlineClients;
    }
  }, {
    key: "setOptions",
    value: function setOptions(options) {
      var _this2 = this;

      var notify = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      _get(_getPrototypeOf(Server.prototype), "setOptions", this).call(this, options);

      if (notify && this.isOnline()) {
        _underscore["default"].each(this.getOnlineClients(), function (client) {
          _this2.tick({
            event: _enum.events.OPTIONS_SYNC,
            data: {
              actorId: _this2.getId(),
              options: options
            },
            to: client.id,
            mainEvent: true
          });
        });
      }
    }
  }, {
    key: "bind",
    value: function bind(bindAddress) {
      if (_underscore["default"].isString(bindAddress)) {
        this.setAddress(bindAddress);
      }

      return _get(_getPrototypeOf(Server.prototype), "bind", this).call(this, this.getAddress());
    }
  }, {
    key: "unbind",
    value: function unbind() {
      var _this3 = this;

      try {
        var _scope = _private.get(this);

        if (this.isOnline()) {
          _underscore["default"].each(this.getOnlineClients(), function (client) {
            _this3.tick({
              to: client.getId(),
              event: _enum.events.SERVER_STOP,
              mainEvent: true
            });
          });
        } // ** clear the heartbeat checking interval


        if (_scope.clientCheckInterval) {
          clearInterval(_scope.clientCheckInterval);
        }

        _scope.clientCheckInterval = null;
        return _get(_getPrototypeOf(Server.prototype), "unbind", this).call(this);
      } catch (err) {
        var serverUnbindError = new _errors.ZeronodeError({
          socketId: this.getId(),
          code: _errors.ErrorCodes.SERVER_UNBIND,
          error: err
        });
        return Promise.reject(serverUnbindError);
      }
    }
  }]);

  return Server;
}(_sockets.Router); // ** Request handlers


exports["default"] = Server;

function _clientPingTick(_ref2) {
  var actor = _ref2.actor,
      stamp = _ref2.stamp;

  var _private$get3 = _private.get(this),
      clientModels = _private$get3.clientModels; // ** PING DATA FROM CLIENT, actor is client id


  var actorModel = clientModels.get(actor);

  if (actorModel) {
    actorModel.ping(stamp);
  }
}

function _clientStopRequest(request) {
  var _private$get4 = _private.get(this),
      clientModels = _private$get4.clientModels;

  var _request$body = request.body,
      actorId = _request$body.actorId,
      options = _request$body.options; // ** just replying acknowledgment

  request.reply({
    stamp: Date.now()
  });
  var actorModel = clientModels.get(actorId);
  if (!actorModel) return;
  actorModel.markStopped();
  actorModel.mergeOptions(options);
  this.emit(_enum.events.CLIENT_STOP, actorModel.toJSON());
}

function _clientConnectedRequest(request) {
  var _scope = _private.get(this);

  var clientModels = _scope.clientModels,
      clientCheckInterval = _scope.clientCheckInterval;
  var _request$body2 = request.body,
      actorId = _request$body2.actorId,
      options = _request$body2.options;
  var actorModel = new _actor["default"]({
    id: actorId,
    options: options,
    online: true
  });
  clientModels.set(actorId, actorModel);

  if (!clientCheckInterval) {
    var config = this.getConfig();
    var clientHeartbeatInterval = config.CLIENT_MUST_HEARTBEAT_INTERVAL || _globals["default"].CLIENT_MUST_HEARTBEAT_INTERVAL;
    _scope.clientCheckInterval = setInterval(_checkClientHeartBeat.bind(this), clientHeartbeatInterval);
  }

  var replyData = {
    actorId: this.getId(),
    options: this.getOptions() // ** replyData {actorId, options}

  };
  request.reply(replyData);
  this.emit(_enum.events.CLIENT_CONNECTED, actorModel.toJSON());
} // ** check clients heartbeat


function _checkClientHeartBeat() {
  var _this4 = this;

  _underscore["default"].each(this.getOnlineClients(), function (actor) {
    if (!actor.isGhost()) {
      actor.markGhost();
    } else {
      actor.markFailed();

      _this4.emit(_enum.events.CLIENT_FAILURE, actor.toJSON());
    }
  });
}

function _clientOptionsSync(_ref3) {
  var actorId = _ref3.actorId,
      options = _ref3.options;

  try {
    var _private$get5 = _private.get(this),
        clientModels = _private$get5.clientModels;

    var actorModel = clientModels.get(actorId); // TODO::remove after some time

    if (!actorModel) {
      throw new Error("Client actor '".concat(actorId, "' is not available on server '").concat(this.getId(), "'"));
    }

    actorModel.setOptions(options);
    this.emit(_enum.events.OPTIONS_SYNC, {
      id: actorModel.getId(),
      newOptions: options
    });
  } catch (err) {
    var clientOptionsSyncHandlerError = new _errors.ZeronodeError({
      socketId: this.getId(),
      code: _errors.ErrorCodes.CLIENT_OPTIONS_SYNC_HANDLER,
      error: err
    });
    clientOptionsSyncHandlerError.description = "Error while handling client options sync on server ".concat(this.getId());
    this.emit('error', clientOptionsSyncHandlerError);
  }
}