"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _zeromq = _interopRequireDefault(require("zeromq"));

var _errors = require("../errors");

var _socket = require("./socket");

var _envelope = _interopRequireDefault(require("./envelope"));

var _enum = require("./enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var _private = new WeakMap();

var DealerSocket =
/*#__PURE__*/
function (_Socket) {
  _inherits(DealerSocket, _Socket);

  function DealerSocket() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        id = _ref.id,
        options = _ref.options,
        config = _ref.config;

    _classCallCheck(this, DealerSocket);

    options = options || {};
    config = config || {};

    var socket = _zeromq["default"].socket('dealer');

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DealerSocket).call(this, {
      id: id,
      socket: socket,
      options: options,
      config: config
    }));
    var _scope = {
      socket: socket,
      state: _enum.DealerStateType.DISCONNECTED,
      connectionPromise: null,
      routerAddress: null
    };

    _private.set(_assertThisInitialized(_this), _scope);

    return _this;
  }

  _createClass(DealerSocket, [{
    key: "getAddress",
    value: function getAddress() {
      var _private$get = _private.get(this),
          routerAddress = _private$get.routerAddress;

      return routerAddress;
    }
  }, {
    key: "setAddress",
    value: function setAddress(routerAddress) {
      var _scope = _private.get(this);

      if (typeof routerAddress === 'string' && routerAddress.length) {
        _scope.routerAddress = routerAddress;
      }
    }
  }, {
    key: "setOnline",
    value: function setOnline() {
      var _scope = _private.get(this);

      _get(_getPrototypeOf(DealerSocket.prototype), "setOnline", this).call(this);

      _scope.state = _enum.DealerStateType.CONNECTED;
    }
  }, {
    key: "getState",
    value: function getState() {
      var _private$get2 = _private.get(this),
          state = _private$get2.state;

      return state;
    }
  }, {
    key: "connect",
    value: function connect(routerAddress, timeout) {
      var _this2 = this;

      if (this.isOnline() && routerAddress === this.getAddress()) {
        return _bluebird["default"].resolve(true);
      }

      var _scope = _private.get(this);

      var connectionPromise = _scope.connectionPromise;
      timeout = timeout || this.getConfig().CONNECTION_TIMEOUT || _enum.Timeouts.CONNECTION_TIMEOUT;

      if (connectionPromise && routerAddress !== this.getAddress()) {
        // ** if trying to connect to other address you need to disconnect first
        var alreadyConnectedError = new Error("Already connected to '".concat(this.getAddress(), "', disconnect before changing connection address to '").concat(routerAddress, "'"));
        return _bluebird["default"].reject(new _errors.ZeronodeError({
          socketId: this.getId(),
          code: _errors.ErrorCodes.ALREADY_CONNECTED,
          error: alreadyConnectedError
        }));
      } // ** if connection is still pending then returning it


      if (connectionPromise && connectionPromise.isPending() && routerAddress === this.getAddress()) return connectionPromise; // ** if connect is called for the first time then creating the connection promise

      _scope.connectionPromise = new _bluebird["default"](function (resolve, reject) {
        var socket = _scope.socket;

        var _this2$getConfig = _this2.getConfig(),
            RECONNECTION_TIMEOUT = _this2$getConfig.RECONNECTION_TIMEOUT;

        RECONNECTION_TIMEOUT = RECONNECTION_TIMEOUT || _enum.Timeouts.RECONNECTION_TIMEOUT;
        var rejectionTimeout = null;

        if (routerAddress) {
          _this2.setAddress(routerAddress);
        }

        var onConnectionHandler = function onConnectionHandler() {
          if (rejectionTimeout) {
            clearTimeout(rejectionTimeout);
          }

          _this2.once(_socket.SocketEvent.DISCONNECT, onDisconnectionHandler);

          _this2.setOnline();

          resolve();
        };

        var onReConnectionHandler = function onReConnectionHandler(fd, endpoint) {
          if (_scope.reconnectionTimeoutInstance) {
            clearTimeout(_scope.reconnectionTimeoutInstance);
            _scope.reconnectionTimeoutInstance = null;
          }

          _this2.once(_socket.SocketEvent.DISCONNECT, onDisconnectionHandler);

          _this2.setOnline();

          _this2.emit(_socket.SocketEvent.RECONNECT, {
            fd: fd,
            endpoint: endpoint
          });
        };

        var onDisconnectionHandler = function onDisconnectionHandler() {
          _this2.setOffline();

          _scope.state = _enum.DealerStateType.RECONNECTING;

          _this2.once(_socket.SocketEvent.CONNECT, onReConnectionHandler);

          if (RECONNECTION_TIMEOUT !== _enum.Timeouts.INFINITY) {
            _scope.reconnectionTimeoutInstance = setTimeout(function () {
              // ** removing reconnection listener
              _this2.removeListener(_socket.SocketEvent.CONNECT, onReConnectionHandler); // ** disconnecting socket


              _this2.emit(_socket.SocketEvent.RECONNECT_FAILURE);

              _this2.disconnect();
            }, RECONNECTION_TIMEOUT);
          }
        };

        if (timeout !== _enum.Timeouts.INFINITY) {
          rejectionTimeout = setTimeout(function () {
            _this2.removeListener(_socket.SocketEvent.CONNECT, onConnectionHandler); // ** reject the connection promise and then disconnect


            var connectionTimeoutError = new Error("Timeout to connect to ".concat(_this2.getAddress(), " "));
            reject(new _errors.ZeronodeError({
              socketId: _this2.getId(),
              code: _errors.ErrorCodes.CONNECTION_TIMEOUT,
              error: connectionTimeoutError
            }));

            _this2.disconnect();
          }, timeout);
        }

        _this2.once(_socket.SocketEvent.CONNECT, onConnectionHandler);

        _this2.attachSocketMonitor();

        socket.connect(_this2.getAddress());
      });
      return _scope.connectionPromise;
    } // ** not actually disconnected

  }, {
    key: "disconnect",
    value: function disconnect() {
      //* closing and removing all listeners on socket
      _get(_getPrototypeOf(DealerSocket.prototype), "close", this).call(this);

      var _scope = _private.get(this);

      var socket = _scope.socket,
          routerAddress = _scope.routerAddress,
          connectionPromise = _scope.connectionPromise,
          reconnectionTimeoutInstance = _scope.reconnectionTimeoutInstance; //* if connection promise is pending then rejecting it

      if (connectionPromise && connectionPromise.isPending()) {
        connectionPromise.reject('Disconnecting');
      }

      if (reconnectionTimeoutInstance) {
        clearTimeout(reconnectionTimeoutInstance);
        _scope.reconnectionTimeoutInstance = null;
      }

      _scope.connectionPromise = null;

      if (this.getState() !== _enum.DealerStateType.DISCONNECTED) {
        socket.disconnect(routerAddress);
        _scope.state = _enum.DealerStateType.DISCONNECTED;
      }

      this.setOffline();
    } // ** Polymorphic functions

  }, {
    key: "request",
    value: function request() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          to = _ref2.to,
          event = _ref2.event,
          data = _ref2.data,
          timeout = _ref2.timeout,
          _ref2$mainEvent = _ref2.mainEvent,
          mainEvent = _ref2$mainEvent === void 0 ? false : _ref2$mainEvent;

      var envelop = new _envelope["default"]({
        type: _enum.EnvelopType.REQUEST,
        tag: event,
        data: data,
        owner: this.getId(),
        recipient: to,
        mainEvent: mainEvent
      });
      return _get(_getPrototypeOf(DealerSocket.prototype), "request", this).call(this, envelop, timeout);
    }
  }, {
    key: "tick",
    value: function tick() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          to = _ref3.to,
          event = _ref3.event,
          data = _ref3.data,
          _ref3$mainEvent = _ref3.mainEvent,
          mainEvent = _ref3$mainEvent === void 0 ? false : _ref3$mainEvent;

      var envelop = new _envelope["default"]({
        type: _enum.EnvelopType.TICK,
        tag: event,
        data: data,
        owner: this.getId(),
        recipient: to,
        mainEvent: mainEvent
      });
      return _get(_getPrototypeOf(DealerSocket.prototype), "tick", this).call(this, envelop);
    }
  }, {
    key: "close",
    value: function () {
      var _close = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var _private$get3, socket;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.disconnect();

              case 2:
                _private$get3 = _private.get(this), socket = _private$get3.socket;
                socket.close();

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function close() {
        return _close.apply(this, arguments);
      }

      return close;
    }()
  }, {
    key: "getSocketMsg",
    value: function getSocketMsg(envelop) {
      return envelop.getBuffer();
    }
  }]);

  return DealerSocket;
}(_socket.Socket);

exports["default"] = DealerSocket;