"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DealerStateType = exports.Timeouts = exports.MetricType = exports.EnvelopType = void 0;

/**
 * Created by artak on 2/15/17.
 */
var EnvelopType = {
  TICK: 1,
  REQUEST: 2,
  RESPONSE: 3,
  ERROR: 4
};
exports.EnvelopType = EnvelopType;
var MetricType = {
  SEND_TICK: 'sendTick',
  SEND_REQUEST: 'sendRequest',
  SEND_REPLY_SUCCESS: 'sendReplySuccess',
  SEND_REPLY_ERROR: 'sendReplyError',
  GOT_TICK: 'gotTick',
  GOT_REQUEST: 'gotRequest',
  GOT_REPLY_SUCCESS: 'gotReplySuccess',
  GOT_REPLY_ERROR: 'gotReplyError',
  REQUEST_TIMEOUT: 'requestTimeout'
};
exports.MetricType = MetricType;
var Timeouts = {
  MONITOR_TIMEOUT: 10,
  // ** when monitor fials restart it after milliseconds
  MONITOR_RESTART_TIMEOUT: 1000,
  REQUEST_TIMEOUT: 10000,
  CONNECTION_TIMEOUT: -1,
  RECONNECTION_TIMEOUT: -1,
  INFINITY: -1
};
exports.Timeouts = Timeouts;
var DealerStateType = {
  CONNECTED: 'connected',
  DISCONNECTED: 'disconnected',
  RECONNECTING: 'reconnecting'
};
exports.DealerStateType = DealerStateType;
var _default = {
  EnvelopType: EnvelopType,
  MetricType: MetricType,
  Timeouts: Timeouts,
  DealerStateType: DealerStateType
};
exports["default"] = _default;