"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _underscore = _interopRequireDefault(require("underscore"));

var _crypto = _interopRequireDefault(require("crypto"));

var _bufferAlloc = _interopRequireDefault(require("buffer-alloc"));

var _bufferFrom = _interopRequireDefault(require("buffer-from"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Parse =
/*#__PURE__*/
function () {
  function Parse() {
    _classCallCheck(this, Parse);
  }

  _createClass(Parse, null, [{
    key: "dataToBuffer",
    // serialize
    value: function dataToBuffer(data) {
      try {
        return (0, _bufferFrom["default"])(JSON.stringify({
          data: data
        }));
      } catch (err) {
        console.error(err);
      }
    } // deserialize

  }, {
    key: "bufferToData",
    value: function bufferToData(data) {
      try {
        var ob = JSON.parse(data.toString());
        return ob.data;
      } catch (err) {
        console.error(err);
      }
    }
  }]);

  return Parse;
}();

var lengthSize = 1;

var Envelop =
/*#__PURE__*/
function () {
  function Envelop(_ref) {
    var type = _ref.type,
        _ref$id = _ref.id,
        id = _ref$id === void 0 ? '' : _ref$id,
        _ref$tag = _ref.tag,
        tag = _ref$tag === void 0 ? '' : _ref$tag,
        data = _ref.data,
        _ref$owner = _ref.owner,
        owner = _ref$owner === void 0 ? '' : _ref$owner,
        _ref$recipient = _ref.recipient,
        recipient = _ref$recipient === void 0 ? '' : _ref$recipient,
        mainEvent = _ref.mainEvent;

    _classCallCheck(this, Envelop);

    if (type) {
      this.setType(type);
    }

    this.id = id || _crypto["default"].randomBytes(20).toString('hex');
    this.tag = tag;
    this.mainEvent = mainEvent;

    if (data) {
      this.data = data;
    }

    this.owner = owner;
    this.recipient = recipient;
  }

  _createClass(Envelop, [{
    key: "toJSON",
    value: function toJSON() {
      return {
        type: this.type,
        id: this.id,
        tag: this.tag,
        data: this.data,
        owner: this.owner,
        recipient: this.recipient,
        mainEvent: this.mainEvent
      };
    }
    /**
       *
       * @param buffer
       * @description {
       *      mainEvent: 1,
       *      type: 1,
       *      idLength: 4,
       *      id: idLength,
       *      ownerLength: 4,
       *      owner: ownerLength,
       *      recipientLength: 4,
       *      recipient: recipientLength,
       *      tagLength: 4,
       *      tag: tagLength
       * @return {{mainEvent: boolean, type, id: string, owner: string, recipient: string, tag: string}}
       */

  }, {
    key: "getBuffer",
    value: function getBuffer() {
      var bufferArray = [];
      var mainEventBuffer = (0, _bufferAlloc["default"])(1);
      mainEventBuffer.writeInt8(+this.mainEvent);
      bufferArray.push(mainEventBuffer);
      var typeBuffer = (0, _bufferAlloc["default"])(1);
      typeBuffer.writeInt8(this.type);
      bufferArray.push(typeBuffer);
      var idBuffer = Envelop.stringToBuffer(this.id.toString(), 'hex');
      bufferArray.push(idBuffer);
      var ownerBuffer = Envelop.stringToBuffer(this.owner.toString(), 'utf-8');
      bufferArray.push(ownerBuffer);
      var recipientBuffer = Envelop.stringToBuffer(this.recipient.toString(), 'utf-8');
      bufferArray.push(recipientBuffer);
      var tagBuffer = Envelop.stringToBuffer(this.tag.toString(), 'utf-8');
      bufferArray.push(tagBuffer);

      if (this.data) {
        bufferArray.push(Parse.dataToBuffer(this.data));
      }

      return Buffer.concat(bufferArray);
    }
  }, {
    key: "getId",
    value: function getId() {
      return this.id;
    }
  }, {
    key: "getTag",
    value: function getTag() {
      return this.tag;
    }
  }, {
    key: "getOwner",
    value: function getOwner() {
      return this.owner;
    }
  }, {
    key: "setOwner",
    value: function setOwner(owner) {
      this.owner = owner;
    }
  }, {
    key: "getRecipient",
    value: function getRecipient() {
      return this.recipient;
    }
  }, {
    key: "setRecipient",
    value: function setRecipient(recipient) {
      this.recipient = recipient;
    } // ** type of envelop

  }, {
    key: "getType",
    value: function getType() {
      return this.type;
    }
  }, {
    key: "setType",
    value: function setType(type) {
      this.type = type;
    } // ** data of envelop

  }, {
    key: "getData",
    value: function getData(data) {
      return this.data;
    }
  }, {
    key: "setData",
    value: function setData(data) {
      this.data = data;
    }
  }, {
    key: "isMain",
    value: function isMain() {
      return !!this.mainEvent;
    }
  }], [{
    key: "readMetaFromBuffer",
    value: function readMetaFromBuffer(buffer) {
      var mainEvent = !!buffer.readInt8(0);
      var type = buffer.readInt8(1);
      var idStart = 2 + lengthSize;
      var idLength = buffer.readInt8(idStart - lengthSize);
      var id = buffer.slice(idStart, idStart + idLength).toString('hex');
      var ownerStart = lengthSize + idStart + idLength;
      var ownerLength = buffer.readInt8(ownerStart - lengthSize);
      var owner = buffer.slice(ownerStart, ownerStart + ownerLength).toString('utf8').replace(/\0/g, '');
      var recipientStart = lengthSize + ownerStart + ownerLength;
      var recipientLength = buffer.readInt8(recipientStart - lengthSize);
      var recipient = buffer.slice(recipientStart, recipientStart + recipientLength).toString('utf8').replace(/\0/g, '');
      var tagStart = lengthSize + recipientStart + recipientLength;
      var tagLength = buffer.readInt8(tagStart - lengthSize);
      var tag = buffer.slice(tagStart, tagStart + tagLength).toString('utf8').replace(/\0/g, '');
      return {
        mainEvent: mainEvent,
        type: type,
        id: id,
        owner: owner,
        recipient: recipient,
        tag: tag
      };
    }
  }, {
    key: "readDataFromBuffer",
    value: function readDataFromBuffer(buffer) {
      var dataBuffer = Envelop.getDataBuffer(buffer);
      return dataBuffer ? Parse.bufferToData(dataBuffer) : null;
    }
  }, {
    key: "getDataBuffer",
    value: function getDataBuffer(buffer) {
      var metaLength = Envelop.getMetaLength(buffer);

      if (buffer.length > metaLength) {
        return buffer.slice(metaLength);
      }

      return null;
    }
  }, {
    key: "fromBuffer",
    value: function fromBuffer(buffer) {
      var _Envelop$readMetaFrom = Envelop.readMetaFromBuffer(buffer),
          id = _Envelop$readMetaFrom.id,
          type = _Envelop$readMetaFrom.type,
          owner = _Envelop$readMetaFrom.owner,
          recipient = _Envelop$readMetaFrom.recipient,
          tag = _Envelop$readMetaFrom.tag,
          mainEvent = _Envelop$readMetaFrom.mainEvent;

      var envelop = new Envelop({
        type: type,
        id: id,
        tag: tag,
        owner: owner,
        recipient: recipient,
        mainEvent: mainEvent
      });
      var envelopData = Envelop.readDataFromBuffer(buffer);

      if (envelopData) {
        envelop.setData(envelopData);
      }

      return envelop;
    }
  }, {
    key: "stringToBuffer",
    value: function stringToBuffer(str, encryption) {
      var strLength = Buffer.byteLength(str, encryption);
      var lengthBuffer = (0, _bufferAlloc["default"])(lengthSize);
      lengthBuffer.writeInt8(strLength);
      var strBuffer = (0, _bufferAlloc["default"])(strLength);
      strBuffer.write(str, 0, strLength, encryption);
      return Buffer.concat([lengthBuffer, strBuffer]);
    }
  }, {
    key: "getMetaLength",
    value: function getMetaLength(buffer) {
      var length = 2;

      _underscore["default"].each(_underscore["default"].range(4), function () {
        length += lengthSize + buffer.readInt8(length);
      });

      return length;
    }
  }]);

  return Envelop;
}();

exports["default"] = Envelop;