"use strict";

var _zeromq = _interopRequireDefault(require("zeromq"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

_zeromq["default"].Context.setMaxThreads(8);

var getMaxThreads = _zeromq["default"].Context.getMaxThreads();

var getMaxSockets = _zeromq["default"].Context.getMaxSockets();

console.log('getMaxThreads', getMaxThreads);
console.log('getMaxSockets', getMaxSockets);

var dealer1 = _zeromq["default"].socket('dealer');

var dealer2 = _zeromq["default"].socket('dealer');

var router1 = _zeromq["default"].socket('router');

var router2 = _zeromq["default"].socket('router'); // ** BUG scenario
// router1.monitor(10, 0)
// router2.monitor(10, 0)
// dealer1.monitor(10, 0)
// dealer2.monitor(10, 0)


var ADDRESS1 = 'tcp://127.0.0.1:5080';
var ADDRESS2 = 'tcp://127.0.0.1:5081';
router1.bindSync(ADDRESS1);
router2.bindSync(ADDRESS2); // ** FIX scenario

router1.monitor(10, 0);
router2.monitor(10, 0);
dealer1.on('connect', function () {
  console.log('dealer1 connected');
});
dealer2.on('connect', function () {
  console.log('dealer2 connected');
});
dealer1.connect(ADDRESS1); // ** IMPORTANT TO START MONITOR dealer1.monitor(10, 0)

dealer2.connect(ADDRESS2); // ** FIX scenario

dealer1.monitor(10, 0);
dealer2.monitor(10, 0);
router2.on('message', function (data) {
  console.log(data);
});
setInterval(function () {// dealer2.send(new Buffer(5));
}, 1000);
setTimeout(function () {
  console.log(1);
  router1.unmonitor();
  router1.unbindSync(ADDRESS1);
  console.log(2);
  setTimeout(function () {
    console.log(3);
    dealer1.removeAllListeners();
    dealer1.unmonitor();
    dealer1.disconnect(ADDRESS1);
  }, 2000);
}, 3000);