"use strict";

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _index = require("../index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var runDealer =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    var routerAddress1, routerAddress2, dealer1, dealer2;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            routerAddress1 = 'tcp://127.0.0.1:5039';
            routerAddress2 = 'tcp://127.0.0.1:5040';
            dealer1 = new _index.Dealer({
              id: 'TestDealer1',
              options: {
                layer: 'DealerLayer1'
              }
            });
            dealer2 = new _index.Dealer({
              id: 'TestDealer2',
              options: {
                layer: 'DealerLayer2'
              }
            });
            dealer1.debugMode(true);
            _context.next = 7;
            return dealer1.connect(routerAddress1);

          case 7:
            _context.next = 9;
            return dealer2.connect(routerAddress2);

          case 9:
            dealer1.on(_index.SocketEvent.RECONNECT, function () {
              console.log('TestDealer1 reconnecting...');
            });
            dealer1.on(_index.SocketEvent.DISCONNECT, function () {
              console.log('TestDealer1 SocketEvent.DISCONNECT');
              console.log('TestDealer1 disconnecting');
              dealer1.disconnect();
            });

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function runDealer() {
    return _ref.apply(this, arguments);
  };
}();

runDealer();