"use strict";

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _index = require("../index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var routerAddress1 = 'tcp://127.0.0.1:5034';
var routerAddress2 = 'tcp://127.0.0.1:5035';

var runDealer =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee() {
    var dealer1, dealer2;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            dealer1 = new _index.Dealer({
              id: 'TestDealer1',
              options: {
                layer: 'DealerLayer1'
              }
            });
            dealer2 = new _index.Dealer({
              id: 'TestDealer2',
              options: {
                layer: 'DealerLayer2'
              }
            });
            dealer1.debugMode(true);
            _context.next = 5;
            return dealer1.connect(routerAddress1);

          case 5:
            _context.next = 7;
            return dealer2.connect(routerAddress2);

          case 7:
            dealer1.on(_index.SocketEvent.RECONNECT, function () {
              console.log('Reconnecting');
            });
            dealer1.on(_index.SocketEvent.DISCONNECT, function () {
              console.log('Dealer 1 SocketEvent.DISCONNECT');
              dealer1.disconnect();
            });

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function runDealer() {
    return _ref.apply(this, arguments);
  };
}();

var runRouter =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3() {
    var router1, router2;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            router1 = new _index.Router({
              id: 'TestRouter1',
              options: {
                layer: 'RouterLayer1'
              }
            });
            router2 = new _index.Router({
              id: 'TestRouter2',
              options: {
                layer: 'RouterLayer2'
              }
            });
            router1.debugMode(true);
            router2.debugMode(true);
            _context3.next = 6;
            return router1.bind(routerAddress1);

          case 6:
            _context3.next = 8;
            return router2.bind(routerAddress2);

          case 8:
            runDealer();
            setTimeout(
            /*#__PURE__*/
            _asyncToGenerator(
            /*#__PURE__*/
            _regenerator["default"].mark(function _callee2() {
              return _regenerator["default"].wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      console.log("Start unbind from ".concat(routerAddress1, " .... "));
                      _context2.next = 3;
                      return router1.unbind();

                    case 3:
                      console.log("Finish unbind from ".concat(routerAddress1, " .... "));

                    case 4:
                    case "end":
                      return _context2.stop();
                  }
                }
              }, _callee2);
            })), 5000);

          case 10:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function runRouter() {
    return _ref2.apply(this, arguments);
  };
}();

runRouter();