"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _zeromq = _interopRequireDefault(require("zeromq"));

var _bluebird = _interopRequireDefault(require("bluebird"));

var _errors = require("../errors");

var _socket = require("./socket");

var _envelope = _interopRequireDefault(require("./envelope"));

var _enum = require("./enum");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var _private = new WeakMap();

var RouterSocket =
/*#__PURE__*/
function (_Socket) {
  _inherits(RouterSocket, _Socket);

  function RouterSocket() {
    var _this;

    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        id = _ref.id,
        options = _ref.options,
        config = _ref.config;

    _classCallCheck(this, RouterSocket);

    options = options || {};
    config = config || {};

    var socket = _zeromq["default"].socket('router');

    _this = _possibleConstructorReturn(this, _getPrototypeOf(RouterSocket).call(this, {
      id: id,
      socket: socket,
      options: options,
      config: config
    }));
    var _scope = {
      socket: socket,
      bindPromise: null,
      bindAddress: null
    };

    _private.set(_assertThisInitialized(_this), _scope);

    return _this;
  }

  _createClass(RouterSocket, [{
    key: "getAddress",
    value: function getAddress() {
      var _private$get = _private.get(this),
          bindAddress = _private$get.bindAddress;

      return bindAddress;
    }
  }, {
    key: "setAddress",
    value: function setAddress(bindAddress) {
      var _scope = _private.get(this);

      if (typeof bindAddress === 'string' && bindAddress.length) {
        _scope.bindAddress = bindAddress;
      }
    } // ** returns promise

  }, {
    key: "bind",
    value: function bind(bindAddress) {
      var _this2 = this;

      if (this.isOnline() && bindAddress === this.getAddress()) {
        return _bluebird["default"].resolve(true);
      }

      var _scope = _private.get(this);

      var bindPromise = _scope.bindPromise;

      if (bindPromise && bindAddress !== this.getAddress()) {
        // ** if trying to bind to other address you need to unbind first
        var alreadyBindedError = new Error("Already binded to '".concat(this.getAddress(), "', unbind before changing bind address to '").concat(bindAddress, "'"));
        return _bluebird["default"].reject(new _errors.ZeronodeError({
          socketId: this.getId(),
          code: _errors.ErrorCodes.ALREADY_BINDED,
          error: alreadyBindedError
        }));
      } // ** if bind is still pending then returning it


      if (bindPromise && bindPromise.isPending() && bindAddress === this.getAddress()) return bindPromise;
      if (bindAddress) this.setAddress(bindAddress);
      _scope.bindPromise = new _bluebird["default"](function (resolve, reject) {
        var socket = _scope.socket;

        _this2.attachSocketMonitor();

        socket.bind(_this2.getAddress(), function (err) {
          if (err) return reject(err);

          _this2.setOnline();

          resolve("Router (".concat(_this2.getId(), ") is binded at address ").concat(_this2.getAddress()));
        });
      });
      return _scope.bindPromise;
    } // ** returns promise

  }, {
    key: "unbind",
    value: function unbind() {
      var _this3 = this;

      return new _bluebird["default"](function (resolve, reject) {
        //* closing and removing all listeners on socket
        _get(_getPrototypeOf(RouterSocket.prototype), "close", _this3).call(_this3);

        var _scope = _private.get(_this3);

        var socket = _scope.socket,
            bindAddress = _scope.bindAddress,
            bindPromise = _scope.bindPromise; //* if bind promise is pending then reject it

        if (bindPromise && bindPromise.isPending()) {
          bindPromise.reject('Unbinding');
        }

        _scope.bindPromise = null;
        socket.unbindSync(bindAddress);

        _this3.setOffline();

        resolve();
      });
    } // ** returns promise

  }, {
    key: "close",
    value: function () {
      var _close = _asyncToGenerator(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee() {
        var _private$get2, socket;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.unbind();

              case 2:
                _private$get2 = _private.get(this), socket = _private$get2.socket;
                socket.close();

              case 4:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function close() {
        return _close.apply(this, arguments);
      }

      return close;
    }() //* Polymorphic Functions

  }, {
    key: "request",
    value: function request() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          to = _ref2.to,
          event = _ref2.event,
          data = _ref2.data,
          timeout = _ref2.timeout,
          _ref2$mainEvent = _ref2.mainEvent,
          mainEvent = _ref2$mainEvent === void 0 ? false : _ref2$mainEvent;

      var envelop = new _envelope["default"]({
        type: _enum.EnvelopType.REQUEST,
        tag: event,
        data: data,
        owner: this.getId(),
        recipient: to,
        mainEvent: mainEvent
      });
      return _get(_getPrototypeOf(RouterSocket.prototype), "request", this).call(this, envelop, timeout);
    }
  }, {
    key: "tick",
    value: function tick() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          to = _ref3.to,
          event = _ref3.event,
          data = _ref3.data,
          _ref3$mainEvent = _ref3.mainEvent,
          mainEvent = _ref3$mainEvent === void 0 ? false : _ref3$mainEvent;

      var envelop = new _envelope["default"]({
        type: _enum.EnvelopType.TICK,
        tag: event,
        data: data,
        owner: this.getId(),
        recipient: to,
        mainEvent: mainEvent
      });
      return _get(_getPrototypeOf(RouterSocket.prototype), "tick", this).call(this, envelop);
    }
  }, {
    key: "getSocketMsg",
    value: function getSocketMsg(envelop) {
      return [envelop.getRecipient(), '', envelop.getBuffer()];
    }
  }]);

  return RouterSocket;
}(_socket.Socket);

exports["default"] = RouterSocket;